<?php
/* 0
 *DZ盒子：www.idzbox.com
 *更多商业插件/模版免费下载 就在dz盒子
 *本资源来源于网络收集,仅供个人学习交流，请勿用于商业用途，并于下载24小时后删除!
 *如果侵犯了您的权益,请及时告知我们,我们即刻删除!
 */


if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
class alipay_pay extends api_pay{
	private $config;
	private $gateway = 'https://www.alipay.com/cooperate/gateway.do';
	public function __construct() {
		parent::__construct();
		$this->config = $this->getconfig();
	}
	public function setorder($orderid, $price, $subject, $body, $showurl){
		global $_G;
		$this->_args = array(
			'partner' 		=> $this->config['pid'],
			'_input_charset' 	=> CHARSET,
			'notify_url' 		=> $_G['siteurl'].'source/plugin/dc_pay/api/alipay/alipay_notify.php',
			'return_url' 		=> $_G['siteurl'].'source/plugin/dc_pay/api/alipay/alipay_return.php',
			'out_trade_no' 		=> $orderid,
			'subject' 		=> $subject,
			'payment_type'=>1,
			'seller_email' 		=> $this->config['account'],
			'extend_param'	=> 'isv^dz11'
		);
		if($body)
			$this->_args['body'] = $body;
		if($showurl)
			$this->_args['show_url'] = $showurl;
		if($this->config['type']==1){
			$this->_args['service'] = 'create_direct_pay_by_user';
			$this->_args['total_fee'] = $price;
		}elseif($this->config['type']==2){
			$this->_args['service']= 'create_partner_trade_by_buyer';
			$this->_args['logistics_type'] = 'EXPRESS';
			$this->_args['logistics_fee'] = 0;
			$this->_args['logistics_payment'] = 'SELLER_PAY';
			$this->_args['price'] = $price;
			$this->_args['quantity'] = 1;
		}elseif($this->config['type']==3){
			$this->_args['service']= 'trade_create_by_buyer';
			$this->_args['logistics_type'] = 'EXPRESS';
			$this->_args['logistics_fee'] = 0;
			$this->_args['logistics_payment'] = 'SELLER_PAY';
			$this->_args['price'] = $price;
			$this->_args['quantity'] = 1;
		}
	}
	public function create_payurl(){
		$this->MD5sign();
		$urlstr = '';
		foreach($this->_args as $key => $val) {
			$urlstr .= $key.'='.rawurlencode($val).'&';
		}
		$urlstr = substr($urlstr, 0,-1);
		return $this->gateway.'?'.$urlstr;
	}
	public function create_payform($button_name, $button_style = '', $method = 'post'){
		$this->MD5sign();
		$sHtml = '<form id="alipaysubmit" name="alipaysubmit" action="'.$this->gateway.'" method="'.$method.'" target="_blank">';
		foreach($this->_args as $key => $val) {
            $sHtml.= '<input type="hidden" name="'.$key.'" value="'.$val.'"/>';
        }
        $sHtml = $sHtml.'<input type="submit" value="'.$button_name.'" style="'.($button_style?$button_style:'background: url(\'source/plugin/dc_pay/api/alipay/logo.gif\') no-repeat ;width: 88px;height: 31px;border: 0px none;cursor: pointer;').'"></form>';
		return $sHtml;
	}
	public function notifycheck(){
		if(!empty($_POST)){
			$chk = $this->tradecheck($_POST);
			if($chk)return 'success';
		}
		return false;
	}
	public function returncheck(){
		if(!empty($_GET)){
			return $this->tradecheck($_GET);
		}
		return false;
	}
	private function tradecheck($notify){
		define('TRADENO', $notify['trade_no']);
		define('ORDERID', $notify['out_trade_no']);
		if(dfsockopen('http://notify.alipay.com/trade/notify_query.do?partner='.$this->config['pid'].'&notify_id='.$notify['notify_id'], 60) !== 'true'){
			return false;
		}
		if(!$this->config['key']) {
			return false;
		}
		ksort($notify);
		$sign = '';
		foreach($notify as $key => $val){
			if($key != 'sign' && $key != 'sign_type') $sign .= "&$key=$val";
		}
		if($notify['sign'] != md5(substr($sign,1).$this->config['key'])) {
			return false;
		}
		if($notify['trade_status'] == 'WAIT_SELLER_SEND_GOODS' || $notify['trade_status'] == 'TRADE_FINISHED' || $notify['trade_status'] == 'TRADE_SUCCESS'){
			return true;
		}
		return false;
	}
	private function MD5sign(){
		unset($this->_args['sign']);unset($this->_args['sign_type']);
		ksort($this->_args);
		$sign = '';
		foreach($this->_args as $key => $val) {
			$sign .= '&'.$key.'='.$val;
		}
		$sign = substr($sign, 1);
		$sign = md5($sign.$this->config['key']);
		$this->_args['sign'] = $sign;
		$this->_args['sign_type'] = 'MD5';
	}
}
?>