<?php
/**
 *      [Discuz!] (C)2015-2099 DARK Inc.
 *      This is NOT a freeware, use is subject to license terms
 *
 *      $Id: paylist.inc.php 7067 2015-01-21 10:28:15Z wang11291895@163.com $
 */

if(!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
	exit('Access Denied');
}

$_lang = lang('plugin/dc_pay');
$config = @include DISCUZ_ROOT.'/source/plugin/dc_pay/data/config.php';
if($_GET['act']=='install'){
	$f=trim($_GET['f']);
	if(submitcheck('confirmed')){
		if(!$f||!isfile($f)||!install($f))
			cpmsg($_lang['installerror'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'error');
		cpmsg($_lang['installsucceed'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'succeed',array('identify' =>$f));
	}
	cpmsg($_lang['intstallcheck'],'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist&act=install&f='.$f,'form', array('identify' => $f));
}elseif($_GET['act']=='uninstall'){
	$f=trim($_GET['f']);
	if(!$config[$f])
		cpmsg($_lang['error'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'error');
	if(submitcheck('confirmed')){
		$paytitle = $config[$f]['title'];
		if(!$f||!isfile($f)||!uninstall($f))
			cpmsg($_lang['uninstallerror'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'error');
		cpmsg($_lang['uninstallsucceed'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'succeed',array('title' =>$paytitle));
	}
	cpmsg($_lang['unintstallcheck'],'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist&act=uninstall&f='.$f,'form', array('title' =>$config[$f]['title']));
}elseif($_GET['act']=='set'){
	$f=trim($_GET['f']);
	if(!$config[$f])
		cpmsg($_lang['error'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'error');
	if(submitcheck('submit')){
		C::import('api/admin','plugin/dc_pay',false);
		C::import($f.'/admin','plugin/dc_pay/api',false);
		$modstr = $f.'_admin';
		if (class_exists($modstr,false)){
			$mobj = new $modstr();
			if(in_array('dosave',get_class_methods($mobj))){
				$mobj->dosave();
			}
			$config[$f]['enable']=dintval($_GET['enable']);
			writeconfig($config);
			cpmsg($_lang['setsucceed'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'succeed');
		}
		
		cpmsg($_lang['error'], 'action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist', 'error');
	}
	showformheader('plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist&f='.$f.'&act=set');
	showtableheader($_lang['set'].'('.$config[$f]['title'].')', '');
	showsetting($_lang['enable'], 'enable', $config[$f]['enable']);
	C::import('api/admin','plugin/dc_pay',false);
	C::import($f.'/admin','plugin/dc_pay/api',false);
	$modstr = $f.'_admin';
	if (class_exists($modstr,false)){
		$mobj = new $modstr();
		if(in_array('doset',get_class_methods($mobj))){
			$mobj->doset();
		}
	}
	showtablefooter();
	showsubmit('submit');
	showformfooter();
	exit;
}
$payarr = array();
$payerror = false;
$entrydir = DISCUZ_ROOT.'./source/plugin/dc_pay/api';
C::import('api/install','plugin/dc_pay',false);
if(file_exists($entrydir)) {
	$d = dir($entrydir);
	while($f = $d->read()) {
		if($f!='.'&&$f!='..'&&is_dir($entrydir.'/'.$f)){
			C::import($f.'/install','plugin/dc_pay/api',false);
			$modstr = $f.'_install';
			if (class_exists($modstr,false)){
				$obj = new $modstr();
				$payarr[$f] = array(
					'logo'=>$obj->logo,
					'title'=>$obj->title,
					'des'=>$obj->des,
					'author'=>$obj->author,
					'version'=>$obj->version,
				);
			}
		}
	}
}

showtableheader($_lang['isinstall'], '');
showsubtitle(array('',$_lang['logo'], $_lang['title'],$_lang['des'],$_lang['author'],$_lang['version'],$_lang['enable'],$_lang['caozuo']));
foreach($config as $k => $c){
	if($payarr[$k]){
		unset($payarr[$k]);
	}else{
		$payerror = true;
		unset($config[$k]);
		continue;
	}
	showtablerow('', array('width="20"', 'width="100"','class="td28"','class="td28"','class="td28"'), 
			array('',
			'<img src="source/plugin/dc_pay/api/'.$k.'/'.$c['logo'].'" />',
			$c['title'],
			$c['des'],
			$c['author'],
			$c['version'],
			$c['enable']?$_lang['yes']:$_lang['no'],
			'<a href="'.ADMINSCRIPT.'?action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist&act=set&f='.$k.'">'.$_lang['set'].'</a>  <a href="'.ADMINSCRIPT.'?action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist&act=uninstall&f='.$k.'">'.$_lang['uninstall'].'</a>'));
}
showtablefooter();
showtableheader($_lang['isnoinstall'], '');
showsubtitle(array('',$_lang['logo'], $_lang['title'],$_lang['des'],$_lang['author'],$_lang['version'],$_lang['caozuo']));
$entrydir = DISCUZ_ROOT.'./source/plugin/dc_pay/api';
C::import('api/install','plugin/dc_pay',false);
foreach($payarr as $k => $c){
	showtablerow('', array('width="20"', 'width="100"','class="td28"','class="td28"', 'class="td28"'), array('','<img src="source/plugin/dc_pay/api/'.$k.'/'.$c['logo'].'" />',$c['title'],$c['des'],$c['author'],$c['version'],'<a href="'.ADMINSCRIPT.'?action=plugins&operation=config&do='.$pluginid.'&identifier=dc_pay&pmod=paylist&act=install&f='.$k.'">'.$_lang['install'].'</a>'));
}
showtablefooter();
if($payerror){
	writeconfig($config);
}
function isfile($str){
	return file_exists(DISCUZ_ROOT.'/source/plugin/dc_pay/api/'.$str.'/'.$str.'_install.php');
}
function uninstall($name){
	global $config;
	C::import('api/install','plugin/dc_pay',false);
	C::import($name.'/install','plugin/dc_pay/api',false);
	$modstr = $name.'_install';
	if (class_exists($modstr,false)){
		$mobj = new $modstr();
		if(in_array('uninstall',get_class_methods($mobj))){
			if($mobj->uninstall()===false)
				return false;
		}
		unset($config[$name]);
		return writeconfig($config);
	}
	return false;
}
function install($name){
	global $config;
	if($config[$name])
		return;
	C::import('api/install','plugin/dc_pay',false);
	C::import($name.'/install','plugin/dc_pay/api',false);
	$modstr = $name.'_install';
	if (class_exists($modstr,false)){
		$mobj = new $modstr();
		if(in_array('install',get_class_methods($mobj))){
			if($mobj->install()===false)
				return false;
		}
		$config[$name]['title']=$mobj->title;
		$config[$name]['des']=$mobj->des;
		$config[$name]['author']=$mobj->author;
		$config[$name]['version']=$mobj->version;
		$config[$name]['logo']=$mobj->logo;
		return writeconfig($config);
	}
	return false;
}
function writeconfig($config){
	$configdata = 'return '.var_export($config, true).";\n\n";
	if($fp = @fopen(DISCUZ_ROOT.'/source/plugin/dc_pay/data/config.php', 'wb')) {
		fwrite($fp, "<?php\n//plugin dc_pay config file, DO NOT modify me!\n//Identify: ".md5($k.$configdata)."\n\n$configdata?>");
		fclose($fp);
		return true;
	}
	return false;
}
?>