<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
class class_vip{
	var $cvar;
	var $groupdata;
	public function __construct(){
		global $_G;
		loadcache('plugin');
		$this->cvar = $_G['cache']['plugin']['dc_vip'];
		$this->groupdata = C::t('#dc_vip#dc_vip_group')->getdata();
		$_G['dc_plugin']['vip']['hash'] = md5($_G['config']['security']['authkey'].md5_file(DISCUZ_ROOT.'./source/plugin/dc_vip/template/sidebar.htm'));
	}
	public function getvipinfo($uid='',$flag = false){
		global $_G;
		$uid = $uid ? $uid : $_G['uid'];
		$uvip = C::t('#dc_vip#dc_vip')->fetch($uid);
		if(empty($uvip))return array();
		if($flag==false)
			$this->update($uvip,'data');
		if(dgmdate($uvip['exptime'],'Y-m-d')>=dgmdate(TIMESTAMP,'Y-m-d')||$flag)
			return $uvip;
		else
			return array();
	}
	public function update($d,$type = 'uid'){
		if($type=='uid')$d=$this->getvipinfo($d,true);
		if(empty($d))return;
		$nowdate = dgmdate(TIMESTAMP,'Y-m-d');
		$update = dgmdate($d['uptime'],'Y-m-d');
		$expdate = dgmdate($d['exptime'],'Y-m-d');
		$isrewardchk = false;
		if($nowdate > $update){
			if($expdate >= $nowdate){
				$gt = $this->cvar['growthv'];
				if($d['isyear']){
					$gt +=$this->cvar['yearv'];
					if(!$d['isreward']&&$this->cvar['fyvipreward'])$isrewardchk = true;
				}
				$day = (strtotime($nowdate) - strtotime($update))/86400;
				$growth = $gt*$day + $d['growth'];
			}else{
				if($update>$expdate){
					$gt = $this->cvar['dropv'];
					$day = (strtotime($nowdate) - strtotime($update))/86400;
					$gt = $gt*$day;
					$growth = $d['growth']-$gt;
				}else{
					$gt = $this->cvar['growthv'];
					$day = (strtotime($expdate) - strtotime($update))/86400;
					if($d['isyear'])$gt +=$this->cvar['yearv'];
					$gt = $gt*$day;
					$day = (strtotime($nowdate) - strtotime($update))/86400;
					$day = $day-1;
					$growth = $gt - $this->cvar['dropv']*$day;
					$growth = $growth + $d['growth'];
					$user = getuserbyuid($d['uid']);
					notification_add($d['uid'], 'system', $this->cvar['endvipmsg'], array('uid' => $d['uid'], 'username' => $user['username']), 1);
				}
				if($growth<0)$growth=0;
			}
			$vgid = $this->get_vip_group_by_growth($growth);
			if($vgid['id']>$d['vgid']){
				$user = getuserbyuid($d['uid']);
				notification_add($d['uid'], 'system', $this->cvar['upvipmsg'], array('uid' => $d['uid'], 'username' => $user['username'], 'vip' => $this->groupdata[$vgid['id']]['grouptitle']), 1);
			}
			$data = array(
				'growth'=>$growth,
				'uptime'=>TIMESTAMP,
				'isyear'=>($d['isyear']&&$d['yearend']>TIMESTAMP)?1:0,
				'vgid'=>$vgid['id'],
			);
			if($isrewardchk){
				$data['growth'] += $this->cvar['fyvipreward'];
				$data['isreward'] = 1;
				notification_add($d['uid'], 'system', lang('plugin/dc_vip','fyvipreward'), array('growth' => $this->cvar['fyvipreward']), 1);
			}
			C::t('#dc_vip#dc_vip')->update($d['uid'],$data);
		}
	}
	public function updategrowth($uid,$growth = 0,$flag = false){
		global $_G;
		$uvip = array();
		if($uid==$_G['uid']){
			$uvip = $_G['dc_plugin']['vip']['user'];
			$flag = true;
		}else{
			$uvip = $this->getvipinfo($uid);
		}
		if(empty($uvip))return;
		$data = array(
			'growth'=>$uvip['growth'] + $growth,
		);
		if($flag){
			$vgid = $this->get_vip_group_by_growth($data['growth']);
			if($vgid['id']>$uvip['vgid']){
				$user = getuserbyuid($uid);
				notification_add($uid, 'system', $this->cvar['upvipmsg'], array('uid' => $uid, 'username' => $user['username'], 'vip' => $this->groupdata[$vgid['id']]['grouptitle']), 1);
			}
			$data['vgid'] = $vgid['id'];
		}
		C::t('#dc_vip#dc_vip')->update($uid,$data);
	}
	public function get_vip_group_by_growth($growth){
		$vgdata = array();
		foreach($this->groupdata as $g){
			if($g['growthlower']<=$growth){
				$vgdata = $g;
			}else{
				break;
			}	
		}
		return $vgdata;
	}
}

//if(md5_file(DISCUZ_ROOT.'./source/plugin/dc_vip/template/sidebar.htm')!='0a266a24a8055d406189d4cd588ef3bf')dexit();
?>