<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

if(!$fromversion)
	$fromversion = trim($_GET['fromversion']);
if($fromversion<'v1.1.1'){
		$sql = <<<EOF
CREATE TABLE `pre_dc_vip_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `orderid` char(32) NOT NULL,
  `status` int(11) DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  `credit` int(11) DEFAULT '0',
  `extcredit` int(11) DEFAULT NULL,
  `price` float(7,2) DEFAULT '0.00',
  `submitdate` int(11) DEFAULT NULL,
  `confirmdate` int(11) DEFAULT NULL,
  `payorderid` varchar(45) DEFAULT NULL,
  `month` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
);
ALTER TABLE `pre_dc_vip_group` ADD COLUMN `highlight` INT(11) NULL DEFAULT NULL  AFTER `hook` ;
ALTER TABLE `pre_dc_vip_group` ADD COLUMN `highlightcolor` varchar(45) NULL DEFAULT NULL  AFTER `hook` ;
EOF;
	runquery($sql);
}
if($fromversion<'v1.1.4'){
	$viphash = md5($_G['config']['security']['authkey'].'c27ea39969541cb3154bb4c2f1bddd09');
	$vipgroup = C::t('#dc_vip#dc_vip_group')->getdata();
	foreach($vipgroup as $vg){
		$vipallow = authcode('s:0:"";','ENCODE', $viphash);
		$viphook = authcode($vg['hook'],'ENCODE', $viphash);
		$vipgroup = C::t('#dc_vip#dc_vip_group')->update($vg['id'],array('allow'=>$vipallow,'hook'=>$viphook));
	}
	
}
if($fromversion<'v1.2.2'){
$sql = <<<EOF
	ALTER TABLE `pre_dc_vip` ADD COLUMN `isreward` TINYINT(1) NULL;
EOF;
	runquery($sql);
}
if($fromversion<'v1.2.3'){
$sql = <<<EOF
	ALTER TABLE `pre_dc_vip` ADD COLUMN `yearend` INT(11) NULL;
EOF;
	runquery($sql);
	DB::query('update %t set `yearend`=`exptime` where `isyear`=%d',array('dc_vip','1'));
}
if($fromversion<'v1.2.4'){
$sql = <<<EOF
CREATE TABLE `pre_dc_vip_key_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `typename` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
);
CREATE TABLE `pre_dc_vip_key` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(255) DEFAULT NULL,
  `viptime` int(4) DEFAULT '0',
  `typeid` smallint(6) DEFAULT '0',
  `sortid` tinyint(1) DEFAULT '0',
  `status` tinyint(1) DEFAULT '0',
  `uid` mediumint(8) DEFAULT '0',
  `dateline` int(10) DEFAULT '0',
  `useddateline` int(10) DEFAULT '0',
  `enddateline` int(10) DEFAULT '0',
  PRIMARY KEY (`id`)
);
EOF;
	runquery($sql);
}
if($fromversion<'v1.2.5'){
	require_once DISCUZ_ROOT.'./source/plugin/dc_pay/payment.lib.class.php';
	$phr = array(
		'plugin'=>'dc_vip',
		'include'=>'payvip.class.php',
		'class'=>'payvip',
		'return'=>'doreturn',
		'notify'=>'donotify',
	);
	PayHook::Register($phr);
}
if($fromversion<'v1.2.6'){
	$sql = <<<EOF
ALTER TABLE `pre_dc_vip` CHANGE COLUMN `yearend` `yearend` INT(11) NULL DEFAULT NULL;
EOF;
	runquery($sql);
	$temptime = TIMESTAMP+31536000;
	DB::query('update %t set `yearend`=`exptime`,`isyear`=%d where `exptime`>%d',array('dc_vip','1',$temptime));
}
$finish = TRUE;
?>
